# spring-rest-example

This project is a example of using Spring REST.

The project uses the [Spock Framework Example Project](https://github.com/spockframework/)

## Prerequisites

- JDK 17 or higher

- Maven use `mvnw` wrapper

## Building with Maven

Downloaded files will be stored in the local Maven repository (typically **user_home**`/.m2/repository`).

Type: test

```shell
./mvnw clean test
```

Type: build


```shell
./mvnw clean package
```

Type: preparation
- create a folder, for example, `project`.
- copy `spring_rest_example-version.jar` from a release to the folder.
  - if you build the application from source, find the file in `target/`.
- copy docker/docker-compose.yml to the folder.
- turn up the database in the `project/docker`:
  ```
  docker-compose up -d
  ```
- wait a minute while the database is bootstrapping.
- now you can connect with the application.

Type: run

After the preparation, run the application in the folder, for example, `project`:
```shell
java -jar spring_rest_example-2.0.1.jar
```

## Author

Kostiantyn Klochko (c) 2023

