package space.kklochko.spring_rest_example.db.repositories.blocks;

import jakarta.persistence.EntityManager;
import jakarta.persistence.RollbackException;

public class TransactionalRemove {
    public <T> boolean run(EntityManager manager, T object)  {
        if(object == null)
            return false;

        try {
            manager.getTransaction().begin();
            manager.remove(object);
            manager.getTransaction().commit();
            return true;
        } catch (RollbackException e) {
            if (manager.getTransaction().isActive()) {
                manager.getTransaction().rollback();
            }
            return false;
        }
    }
}
