package space.kklochko.spring_rest_example.models;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;

import java.util.List;
import java.util.UUID;

@Table(name="patients")
@Entity
@AllArgsConstructor
@Data
public class Patient {
    @Id
    @Column(nullable = true)
    private UUID id;
    private String name;
    private short age;
    private String phone;

    @OneToMany(cascade = CascadeType.ALL, mappedBy="patient")
    private List<Indicator> indicators;

    @ManyToOne
    private Department department;

    public Patient() {
        setId(UUID.randomUUID());
        setName("");
        setAge((short) 0);
        setPhone("");
    }

    public Patient(UUID id, String name, int age, String phone) {
        setId(id);
        setName(name);
        setAge((short) age);
        setPhone(phone);
    }

    public Patient(UUID id, String name, short age, String phone) {
        setId(id);
        setName(name);
        setAge(age);
        setPhone(phone);
    }

    public Patient(String name, int age, String phone) {
        setId(UUID.randomUUID());
        setName(name);
        setAge((short) age);
        setPhone(phone);
    }

    public Patient(String name, short age, String phone) {
        setId(UUID.randomUUID());
        setName(name);
        setAge(age);
        setPhone(phone);
    }
}

