package space.kklochko.spring_rest_example.models.factories;

import lombok.AllArgsConstructor;
import lombok.Getter;
import space.kklochko.spring_rest_example.models.Token;
import space.kklochko.spring_rest_example.security.tokens.StringTokenFactory;

@AllArgsConstructor
@Getter
public class TokenFactory {
    private StringTokenFactory factory;

    public TokenFactory() {
        setFactory(null);
    }

    public Token create(String username, String role) {
        Token token = new Token();

        token.setUsername(username);
        token.setRole(role);
        token.setToken(getFactory().create(username));

        return token;
    }

    public void setFactory(StringTokenFactory factory) {
        this.factory = factory;
    }
}

