package space.kklochko.spring_rest_example.security.tokens

import spock.lang.Specification
import spock.lang.Subject

class SimpleRandomTokenSpec extends Specification {
    def "Create a token that based on sha256"() {
        given: "I have a token factory"
        @Subject
        def factory = new SimpleRandomToken()

        and: "I have a input data"
        String input = "hello"

        when: "I create a token"
        String token = factory.create(input)

        then: "The token is the same if the same input data."
        token.length() == 64
    }

    def "Token must be different for the same input data"() {
        given: "I have a token factory"
        @Subject
        def factory = new SimpleRandomToken()

        and: "I have a input data"
        String input = "hello"

        when: "I create tokens"
        String token = factory.create(input)
        String token2 = factory.create(input)

        then: "The tokens are different"
        token != token2
    }
}

