package space.kklochko.spring_rest_example.security.tokens

import spock.lang.Specification
import spock.lang.Subject

class SimpleTokenSpec extends Specification {
    def "Create a token that based on sha256"() {
        given: "I have a token factory"
        @Subject
        def factory = new SimpleToken()

        when: "I create a token"
        String token = factory.create(input)

        then: "The token is the same if the same input data."
        expectedToken == token

        where: "I have the expected data"
        input                  || expectedToken
        "abc"                  || "ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad"
        "random numbers232341" || "7f4b80b2b09ae4326f78b1a9782c807af0a7d0194bffb05602a6585466b4c43e"
    }
}

